SystemOrganization addCategory: #'Keymapping-Tools-Spec'!

ComposableModel subclass: #KMDescription
	instanceVariableNames: 'droplist list okButton collectingBlock categories displayList sortingBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Keymapping-Tools-Spec'!

!KMDescription commentStamp: '<historical>' prior: 0!
A KMDescription is a window showing the description of shortcuts for a specified set of symbols reprensenting KMCategories!

!KMDescription class methodsFor: 'example' stamp: 'BenjaminVanRyseghem 4/6/2012 17:23'!
example

	| d |
	d := KMDescription new.
	d categories: #(GlobalShortcuts MonticelloShortcuts TextEditor).
	d openWithSpec! !

!KMDescription class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 4/6/2012 17:14'!
internSpec
	<spec>
	
	^ {#Panel.
			#useProportionalLayout.
			#add:. {{#model. #droplist. #internSpec}.
						#layout:. {#FrameLayout. #class.
										#fractions:offsets:. (0@0 corner: 0.6@0). (0@0 corner: 0@25)}}.
			#add:. {{#model. #displayList. #internSpec}.
						#layout:. {#FrameLayout. #class.
										#fractions:offsets:. (0.6@0 corner: 1@0). (0@0 corner: 0@25)}}.
			#add:. {{#model. #list. #internSpec}.
						#layout:. {#FrameLayout. #class.
										#fractions:offsets:. (0@0 corner: 1@1). (0@25 corner: 0@(-25))}}.
			#add:. {{#model. #okButton. #internSpec}.
						#layout:. {#FrameLayout. #class.
										#fractions:offsets:. (1@1 corner: 1@1). (-75@(-25) corner: 0@0)}}.
			#hSpaceFill.
			#vSpaceFill }! !

!KMDescription class methodsFor: 'specs' stamp: 'BenjaminVanRyseghem 4/6/2012 15:46'!
title

	^ 'Shortcuts description'! !

!KMDescription methodsFor: 'accessing' stamp: 'GuillermoPolito 5/1/2012 12:26'!
categories
	
	^ categories! !

!KMDescription methodsFor: 'protocol' stamp: 'BenjaminVanRyseghem 4/6/2012 15:34'!
categories: aCollectionOfSymbols
	| cats |
	
	cats := aCollectionOfSymbols collect: [:e | KMRepository default categoryForName: e].
	categories contents: cats! !

!KMDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/6/2012 15:38'!
displayList
	
	^ displayList! !

!KMDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/6/2012 15:00'!
droplist
	
	^ droplist! !

!KMDescription methodsFor: 'private' stamp: 'BenjaminVanRyseghem 4/6/2012 15:49'!
initialExtent

	^  (600@350)! !

!KMDescription methodsFor: 'initialization' stamp: 'StephaneDucasse 5/17/2012 19:32'!
initialize
	"Initialization code for KMDescription"
	| updatingBlock |
	super initialize.

	droplist := self instantiate: DropListModel.
	list := self instantiate: MultiColumnListModel.
	okButton := self instantiate: ButtonModel.
	categories := nil asValueHolder.
	displayList := self instantiate: DropListModel.
	
	displayList items: {
		DropListItem 
			named:'shortcut	:	description' 
			do: [ 
					collectingBlock := [:e | {e shortcut asString. ':'. e description asString} ].
					sortingBlock := [:a :b | true ]].
		DropListItem 
			named:'description	:	shortcut' 
			do: [ 
					collectingBlock := [:e | {e description asString. ':'. e shortcut asString} ].
					sortingBlock := [:a :b | a first < b first ]]}.
	
	
	updatingBlock := [:col || dropListItems |
		dropListItems := col collect: [:cat | DropListItem named: cat name do: [| items |
																items := (cat entriesAt: #all) keymaps collect: [:e | collectingBlock value: e ].
																list items:  (items sorted: sortingBlock) ]].
		droplist items: dropListItems ]	.
	
	displayList whenSelectedItemChanged: [ updatingBlock value: categories contents ].

	
	list 
		wrappingBlock: [ :e | e ];
		allowToSelect: false.
		
	categories whenChangedDo: [:col | updatingBlock value: col ].
	okButton 
			label: 'Close';
			state: false;
			action: [ self delete ].! !

!KMDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/6/2012 15:00'!
list
	
	^ list! !

!KMDescription methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/6/2012 15:00'!
okButton
	
	^ okButton! !
